Option default integer
MODE 1
TILE height 12
Const FW=MM.Info(FONTWIDTH): FH=MM.Info(FONTHEIGHT)
Const CHR=MM.HRes\FW: CVR=MM.VRes\FH
Const RMax=200
Dim string LDisk$="A:",RDisk$="A:"        LENGTH 2
Dim string LDir$="/",RDir$="/"            LENGTH 64
Dim string LMask$="*",RMask$="*"          LENGTH 16
Dim string LFList$(RMax),RFList$(RMax)    LENGTH 64

Dim string  PSide$="L"                    LENGTH 1
Dim Integer LFLS%(2),RFLS%(2) 'FList Struct (RQ,DQ,FQ)
Dim integer LFLIndx,RFLIndx

Dim integer LPPos,RPPos,LFLTop,RFLTop
Dim integer CKey,Tick1s

Dim integer c(15)=(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15)
Colour Map c(),c()
'==========================================================
'INTERRUP ROUTINES
Sub ISR_Tick1s
  Inc Tick1s
End Sub
'For i=32 To 255:Print Chr$(i);:Next
'==========================================================
BEGIN:
CLS
Timer =0
SetTick 1000,ISR_Tick1s,1
If MM.Info(SDCARD)="Ready" Then RDisk$="B:"
PanelsReStart()
'---------------
Do
CKey=Asc(Inkey$)
If CKey<>0 Then
Select Case CKey
Case 9    'Tap
  SetPControl("TAB")
Case 13   'Enter
  EnterControl()
Case 27   'Escape
  CLS : End
Case 128  'Up
  SetPControl("UP")
Case 129  'Dn
  SetPControl("DWN")
Case 130  'Left
  SetPControl("TOP")
Case 131  'Right
  SetPControl("BOT")
Case 139  'Alt
  SetAltPControl()
Case 145  'F1-Help
  SetPControl("DIS")
  PrintHelp()
  PanelsReStore()
Case 146  'F2-ReName
  SetPControl("DIS")
  W_F2_ReNAME()
  PanelsReStart()
Case 147  'F3-List
  SetPControl("DIS")
  CLS
  On ERROR IGNORE
  List GetCurrFullName$(PSide$)
  On ERROR ABORT
  Do :Loop While Inkey$=""
  PanelsReStore()
Case 148  'F4-Edit
  SetPControl("DIS")
  W_F4_Edit()
  PanelsReStart()
Case 149  'F5-Copy
  SetPControl("DIS")
  W_F5_Copy()
  PanelsReStart()
Case 150  'F6-Move
  SetPControl("DIS")
  W_F6_Move()
  PanelsReStart()
Case 151  'F7-MkDir
  SetPControl("DIS")
  W_F7_MkDIR()
  PanelsReStart()
Case 152  'F8-Delete
  SetPControl("DIS")
  W_F8_DELETE()
  PanelsReStart()
Case Else
  Print @(0,456)CKey;"  ";  'KEY CODE
End Select
Timer =0
EndIf
'-------------------------
If Tick1s Then PrintTime()
If Timer>30000 Then
  SSMatrix()
  CLS :Timer =0
  PanelsReStore()
EndIf
Loop
'ENTER CONTROL ============================================
Sub EnterControl()
If PSide$="L" Then
  'Left Panel Enter
  If Mid$(LFList$(LFLIndx),1,1)="/" Then
    Chdir Mid$(LFList$(LFLIndx),2,63)
  EndIf
  If Mid$(LFList$(LFLIndx),1,2)=".." Then
    Chdir ".."
  EndIf
  If Instr(LFList$(LFLIndx),".bas") Then
    Run LFList$(LFLIndx)
  EndIf
  If Instr(LFList$(LFLIndx),".bmp") Then
    CLS : Load image LFList$(LFLIndx)
    Do : Loop While Inkey$=""
    PanelsReStart()
  EndIf
  LDir$=Mid$(Cwd$,3,Len(Cwd$)-2)+"/"
  'LDir$=Mid$(Cwd$,3,63)
  LPanelShow():SetPControl("ENA")
Else
  'Right Panel Enter
  If Mid$(RFList$(RFLIndx),1,1)="/" Then
    Chdir Mid$(RFList$(RFLIndx),2,63)
  EndIf
  If Mid$(RFList$(RFLIndx),1,2)=".." Then
    Chdir ".."
  EndIf
  If Instr(RFList$(RFLIndx),".bas") Then
    Run RFList$(RFLIndx)
  EndIf
  If Instr(RFList$(RFLIndx),".bmp") Then
    CLS : Load image RFList$(RFLIndx)
    Do : Loop While Inkey$=""
    PanelsReStart()
  EndIf
  RDir$=Mid$(Cwd$,3,Len(Cwd$)-2)+"/"
  'RDir$=Mid$(Cwd$,3,63)
  RPanelShow():SetPControl("ENA")
EndIf
End Sub
'================================
Sub SetPControl(CTRL$)
Local STRING COM$
If PSide$="L" Then
'Left Panel Control ---------
Select Case CTRL$
Case "TAB"
  PSide$="R"
  SetPControl("DIS")
  SetPControl("ENA")
Case "UP"
  TILE 1,1+LPPos,c(15),c(0),38,1
  If LFLIndx>0 Then
    Inc LFLIndx,-1
    If LPPos>0 Then
      Inc LPPos,-1
    Else
      If LFLTop>0 Then Inc LFLTop,-1
      FLPrint(LFList$(),LFLTop,1,1,38,32)
    EndIf
  EndIf
  TILE 1,1+LPPos,c(0),c(15),38,1
Case "DWN"
  TILE 1,1+LPPos,c(15),c(0),38,1
  If LFLIndx<LFLS%(0) Then
    Inc LFLIndx
    If LPPos<32 Then
      Inc LPPos
    Else
      Inc LFLTop
      FLPrint(LFList$(),LFLTop,1,1,38,32)
    EndIf
  EndIf
  TILE 1,1+LPPos,c(0),c(15),38,1
Case "TOP"
  TILE 1,1+LPPos,c(15),c(0),38,1
  LFLIndx=0:LFLTop=0:LPPos=0
  FLPrint(LFList$(),LFLTop,1,1,38,32)
  TILE 1,1+LPPos,c(0),c(15),38,1
Case "BOT"
  TILE 1,1+LPPos,c(15),c(0),38,1
  If (LFLIndx-LPPos)+32<LFLS%(0) Then
    Inc LFLTop,32:Inc LFLIndx,32
    If LFLTop+LPPos>LFLS%(0) Then LFLIndx=LFLS%(0):LPPos=LFLIndx-LFLTop
  Else
    LFLIndx=LFLS%(0):LPPos=LFLS%(0)-LFLTop
  EndIf
  FLPrint(LFList$(),LFLTop,1,1,38,32)
  TILE 1,1+LPPos,c(0),c(15),38,1
End Select
  'Print File Name on Right Panel
  COM$=Mid$(LFList$(LFLIndx),1,38)
  Print @(8,420);COM$+Space$(38-Len(COM$))
  COM$=Mid$(LFList$(LFLIndx),39,38)
  Print @(8,432);COM$+Space$(38-Len(COM$))
'Right Panel Control --------
Else
Select Case CTRL$
Case "TAB"
  PSide$="L"
  SetPControl("DIS")
  SetPControl("ENA")
Case "UP"
  TILE 41,1+RPPos,c(15),c(0),38,1
  If RFLIndx>0 Then
    Inc RFLIndx,-1
    If RPPos>0 Then
      Inc RPPos,-1
    Else
      If RFLTop>0 Then Inc RFLTop,-1
      FLPrint(RFList$(),RFLTop,41,1,38,32)
    EndIf
  EndIf
  TILE 41,1+RPPos,c(0),c(15),38,1
Case "DWN"
  TILE 41,1+RPPos,c(15),c(0),38,1
  If RFLIndx<RFLS%(0) Then
    Inc RFLIndx
    If RPPos<32 Then
      Inc RPPos
    Else
      Inc RFLTop
      FLPrint(RFList$(),RFLTop,41,1,38,32)
    EndIf
  EndIf
  TILE 41,1+RPPos,c(0),c(15),38,1
Case "TOP"
  TILE 41,1+RPPos,c(15),c(0),38,1
  RFLIndx=0:RFLTop=0:RPPos=0
  FLPrint(RFList$(),RFLTop,41,1,38,32)
  TILE 41,1+RPPos,c(0),c(15),38,1
Case "BOT"
  TILE 41,1+RPPos,c(15),c(0),38,1
  If (RFLIndx-RPPos)+32<RFLS%(0) Then
    Inc RFLTop,32:Inc RFLIndx,32
    If RFLTop+RPPos>RFLS%(0) Then RFLIndx=RFLS%(0):RPPos=RFLIndx-RFLTop
  Else
    RFLIndx=RFLS%(0):RPPos=RFLS%(0)-RFLTop
  EndIf
  FLPrint(RFList$(),RFLTop,41,1,38,32)
  TILE 41,1+RPPos,c(0),c(15),38,1
End Select
  'Print File Name on Right Panel
  COM$=Mid$(RFList$(RFLIndx),1,38)
  Print @(328,420);COM$+Space$(38-Len(COM$))
  COM$=Mid$(RFList$(RFLIndx),39,38)
  Print @(328,432);COM$+Space$(38-Len(COM$))
EndIf
'---- Common Actions ------------------
Select Case CTRL$
Case "DIS"
  TILE  1,1+LPPos,c(15),c(0),38,1
  TILE 41,1+RPPos,c(15),c(0),38,1
Case "ENA"
  If PSide$="L" Then
    Drive LDisk$
    TILE  1,1+LPPos,c(0),c(15),38,1
  Else
    Drive RDisk$
    TILE 41,1+RPPos,c(0),c(15),38,1
  EndIf
End Select
'---- Print Command Line --------------
If PSide$="L" Then
  COM$=LDisk$+LDir$+">"
  Print @(0,456);COM$+Space$(80-Len(COM$))
Else
  COM$=RDisk$+RDir$+">"
  Print @(0,456);COM$+Space$(80-Len(COM$))
EndIf
End Sub
'ALT PANEL FUNCTIONS --------------------------------------
Sub  SetAltPControl()
PrintAltFMenu()
Do :CKey=Asc(Inkey$):Loop While CKey=0
Select Case CKey
Case 145    'F1
  SetPControl("DIS")
  LDisk$=WDiskSelect(2,15)
  LPanelShow():SetPControl("ENA")
Case 146    'F2
  SetPControl("DIS")
  RDisk$=WDiskSelect(42,15)
  RPanelShow():SetPControl("ENA")
End Select
PrintFMenu()
End Sub
'FUNCTIONS_KEY_SUBRUTINES =================================
Function WDiskSelect(x,y) As string
Local TEMP$
Local N,P
  OpenWindow("DISK:",x%,y%,35,5)
  Drive "A:":Inc N
  x=x+1
  y=y+1:Print @(x*8,y*12)"   Drive   |   Size   |   Free    "
  y=y+1:Print @(x*8,y*12)"-----------|----------|-----------"
  y=y+1:Print @(x*8,y*12)" A: FlashFS|";
  TEMP$=Str$(MM.Info(DISK SIZE)\1024)+"|":Print Space$(11-Len(TEMP$));TEMP$;
  TEMP$=Str$(MM.Info(FREE SPACE)\1024):Print Space$(10-Len(TEMP$));TEMP$;
  y=y+1
If MM.Info(SDCARD)="Ready" Then
  Drive "B:":Inc N
  Print @(x*8,y*12)" B: SD Card|";
  TEMP$=Str$(MM.Info(DISK SIZE)\1024)+"|":Print Space$(11-Len(TEMP$));TEMP$;
  TEMP$=Str$(MM.Info(FREE SPACE)\1024):Print Space$(10-Len(TEMP$));TEMP$;
Else
  Print @(x*8,y*12)" B: SD Card|   NO Disk Drive !    ";
EndIf
Do
  If P=0 Then
    TILE x,y-1,c(0),c(7),34,1
    TILE x,y,c(15),c(0),34,1
    TEMP$="A:"
  Else
    TILE x,y-1,c(15),c(0),34,1
    TILE x,y,c(0),c(7),34,1
    TEMP$="B:"
  EndIf
  Do :CKey=Asc(Inkey$):Loop While CKey=0
  If N>1 Then P=P Xor 1
Loop Until CKey=13
TILE x,y-1,c(15),c(0),34,1
TILE x,y,c(15),c(0),34,1
WDiskSelect=TEMP$
End Function
'------------------------------------------------
Sub W_F2_ReNAME()
Local string TEMP$
  Color c(15),c(1)
  OpenWindow("ReName:",4,14,71,7)
  Chdir GetCurrFullPath$(PSide$)
  Print @(48,192);GetCurrFullPath$(PSide$);
  Print @(72,204);GetCurrName$(PSide$);
  Print @(48,216);"AS";
  Color c(15),c(0)
  Print @(64,240);Space$(64);
  If Mid$(GetCurrName$(PSide$),1,1)="/" Then
    Print @(64,240);: Input ">/",TEMP$
    If TEMP$<>"" Then
      On ERROR ignore
      Rename Mid$(GetCurrName$(PSide$),2,63) As TEMP$
    EndIf
  Else
    Print @(64,240);: Input ">",TEMP$
    If TEMP$<>"" Then
      On ERROR ignore
      Rename GetCurrName$(PSide$) As TEMP$
    EndIf
  EndIf
  W_ERROR_MSG()
End Sub
'------------------------------------------------
Sub W_F4_Edit()
Select Case Mid$(GetCurrName$(PSide$),1,1)
Case "."
  Local string TEMP$
  Color c(15),c(1)
  OpenWindow("EDIT New File",4,14,71,6)
  Print @(48,192);GetCurrFullPath$(PSide$);
  Color c(15),c(0)
  Print @(56,216);Space$(65);
  Print @(56,216);: Input ">",TEMP$
  Color c(15),c(0)
  If TEMP$<>"" Then Edit
Case "/"
Case Else
  Edit GetCurrFullPath$(PSide$)
End Select
End Sub
'------------------------------------------------
Sub W_F5_Copy()
Local string TEMP$
  Color c(15),c(1)
  OpenWindow("Copy:",4,14,71,10)
  Chdir GetCurrFullPath$(PSide$)
  Print @(48,192);GetCurrFullPath$(PSide$);
  Print @(72,204);GetCurrName$(PSide$);
  Print @(48,216);"to";
  Print @(48,240);GetCurrFullPath$(OpSide$());
  Print @(72,252);GetCurrName$(PSide$);
  Color c(15),c(0)
  Print @(64,276);Space$(65);
  Print @(64,276);: Input ">",TEMP$
  Color c(15),c(0)
  If TEMP$<>"" Then
    TEMP$=GetCurrFullPath$(OpSide$())+TEMP$
  Else
    TEMP$=GetCurrFullPath$(OpSide$())+GetCurrName$(PSide$)
  EndIf
  On ERROR ignore
  Copy GetCurrFullName$(PSide$) To TEMP$
  W_ERROR_MSG()
End Sub
'------------------------------------------------
Sub W_F6_MOVE()
Local string TEMP$
  Color c(15),c(1)
  OpenWindow("Move:",4,14,71,9)
  'Chdir GetCurrFullPath$(PSide$)
  Print @(48,192);GetCurrFullPath$(PSide$);
  Print @(72,204);GetCurrName$(PSide$);
  Print @(48,216);"to";
  Print @(48,240);GetCurrFullPath$(OpSide$());
  Print @(72,252);GetCurrName$(PSide$);
  Color c(15),c(0)
  Do :CKey=Asc(Inkey$):Loop While CKey=0
  If CKey=13 Then
    TEMP$=GetCurrFullPath$(OpSide$())+GetCurrName$(PSide$)
    On ERROR ignore
    Copy GetCurrFullName$(PSide$) To TEMP$
    If Not MM.Errno Then
      Kill GetCurrFullName$(PSide$)
    EndIf
    W_ERROR_MSG()
  EndIf
End Sub
'------------------------------------------------
Sub W_F7_MkDIR()
Local string TEMP$
  Color c(15),c(1)
  OpenWindow("MkDir:",4,14,71,6)
  TEMP$=GetCurrFullPath$(PSide$)
  Chdir TEMP$
  Print @(48,192);TEMP$
  Color c(15),c(0)
  Print @(56,216);Space$(65);
  Print @(56,216);: Input ">/",TEMP$
  Color c(15),c(0)
  If TEMP$<>"" Then Mkdir TEMP$
End Sub
'------------------------------------------------
Sub W_F8_DELETE()
  Color c(15),c(1)
  OpenWindow("Delete:",4,14,71,5)
  Chdir GetCurrFullPath$(PSide$)
  Print @(48,192);GetCurrFullPath$(PSide$);
  Color c(8),c(0)
  Print @(72,204);Space$(64);
  Print @(72,204);GetCurrName$(PSide$);
  Color c(15),c(0)
  Do :CKey=Asc(Inkey$):Loop While CKey=0
  If CKey=13 Then
    If Mid$(GetCurrName$(PSide$),1,1)="/" Then
      On ERROR ignore
      Kill Mid$(GetCurrName$(PSide$),2,63)
      W_ERROR_MSG()
    Else
      Kill GetCurrName$(PSide$)
    EndIf
  EndIf
End Sub
'Window ERROR MSG -------------------------------
Sub W_ERROR_MSG()
Local integer x,l=Len(MM.ErrMsg$)
If MM.Errno Then
  Color c(15),c(8)
  l=Len(MM.ErrMsg$)+4: x=40-(l\2)
  OpenWindow("ERROR:",x,24,l,5)
  Print @((x+2)*8,26*12);
  Print MM.ErrMsg$;
  Color c(15),c(0)
  On ERROR CLEAR
  Do : Loop While Inkey$=""
EndIf
On ERROR ABORT
End Sub
'======================================================
Sub GetFList(Disk$,Folder$,Search$,FList$(),FLS%())
Local string FName$
Local integer RQt,DQt,FQt
Drive Disk$
Chdir Folder$
FList$(RQt)=".."
FName$=Dir$("*",DIR)
Do While FName$<>""
  Inc RQt: Inc DQt: If RQt=RMax Then Exit Do
  FList$(RQt)="/"+FName$
  FName$=Dir$()
Loop
FName$=Dir$(Search$,FILE)
Do While FName$<>""
  Inc RQt: Inc FQt: If RQt=RMax Then Exit Do
  FList$(RQt)=FName$
  FName$=Dir$()
Loop
FList$(RQt+1)=""
FLS%(0)=RQt
FLS%(1)=DQt
FLS%(2)=FQt
End Sub
'==========================================================
Function GetCurrFullName$(SIDE$) As string
If SIDE$="L" Then
  'GetCurrFullName$=LDisk$+LDir$+"/"+LFList$(LFLIndx)
  GetCurrFullName$=GetCurrFullPath$(SIDE$)+LFList$(LFLIndx)
Else
  'GetCurrFullName$=RDisk$+RDir$+"/"+RFList$(RFLIndx)
  GetCurrFullName$=GetCurrFullPath$(SIDE$)+RFList$(RFLIndx)
EndIf
End Function
'--------------------------------------
Function GetCurrName$(SIDE$) As string
If SIDE$="L" Then
  GetCurrName$=LFList$(LFLIndx)
Else
  GetCurrName$=RFList$(RFLIndx)
EndIf
End Function
'------------------------------------------------
Function GetCurrFullPath$(SIDE$) As string
If SIDE$="L" Then
  If Len(Ldir$)>1 Then
    GetCurrFullPath$=LDisk$+LDir$+"/"
  Else
    GetCurrFullPath$=LDisk$+LDir$
  EndIf
Else
  If Len(Ldir$)>1 Then
    GetCurrFullPath$=RDisk$+RDir$+"/"
  Else
    GetCurrFullPath$=RDisk$+RDir$
  EndIf
EndIf
End Function
'------------------------------------------------
Function OpSide$() As string
If PSide$="L" Then OpSide$="R" Else OpSide$="L"
End Function
'==========================================================
'Panels Interface ReWrite  -------------
Sub PanelsReStart()
  PrintFMenu()
  LPanelShow()
  RPanelShow()
  SetPControl("ENA")
End Sub
'Panels Interface Restore -------------
Sub PanelsReStore()
  PrintFMenu()
  LPrintPanel
  RPrintPanel
  SetPControl("ENA")
End Sub
'--------------------------------LPanel
Sub LPanelShow()
SetPControl("DIS")
LPPos=0:LFLIndx=0:LFLTop=0
GetFList(LDisk$,LDir$,LMask$,LFList$(),LFLS%())
LPrintPanel
End Sub
Sub LPrintPanel
OpenWindow(LDisk$+" ["+LMask$+"]",0,0,39,37)
WBar(0,34,39)
FLPrint(LFList$(),LFLTop, 1,1,38,32)
Print @(48,444)" Folders:";LFLS%(1);", Files:";LFLS%(2);" "
End Sub
'--------------------------------RPanel
Sub RPanelShow()
SetPControl("DIS")
RPPos=0:RFLIndx=0:RFLTop=0
GetFList(RDisk$,RDir$,RMask$,RFList$(),RFLS%())
RPrintPanel
End Sub
Sub RPrintPanel
OpenWindow(RDisk$+" ["+RMask$+"]",40,0,39,37)
WBar(40,34,39)
FLPrint(RFList$(),RFLTop,41,1,38,32)
Print @(368,444)" Folders:";RFLS%(1);", Files:";RFLS%(2);" "
End Sub
'================================
Sub OpenWindow(Titl$,xc,yc,wc,hc)
Local integer i,x=(xc+1)*8,y=(yc+1)*12
Local string TEMP$=Space$(wc-1)
  For i=0 To hc-2     'Clear space in frame
    Print @(x,y) TEMP$;
    Inc y,12
  Next
  WFrame(xc,yc,wc,hc)
  Print @((xc+2)*8,yc*12)Chr$(181);Titl$;Chr$(198);
End Sub
'----------------------
Sub WFrame(xc,yc,wc,hc)
Local integer x,y
  Print @(xc*8,yc*12)Chr$(201);
  For x=xc+1 To xc+wc-1
    Print Chr$(205);
  Next
  Print @((xc+wc)*8,yc*12)Chr$(187);
  For y=yc+1 To yc+hc-1
    Print @(xc*8,y*12)Chr$(186);
    Print @((xc+wc)*8,y*12)Chr$(186);
  Next
  Print @(xc*8,(yc+hc)*12)Chr$(200);
  For x=xc+1 To xc+wc-1
    Print Chr$(205);
  Next
  Print @((xc+wc)*8,(yc+hc)*12)Chr$(188);
End Sub
'----------------------
Sub WBar(xc,yc,wc)
Local integer x
  Print @(xc*8,yc*12)Chr$(199);
  For x=xc+1 To xc+wc-1
    Print Chr$(196);
  Next
  Print @((xc+wc)*8,yc*12)Chr$(182);
End Sub
'==========================================================
'PRINT File List on Panel --------------
Sub FLPrint(Flist$(),top,xc,yc,wc,hc)
Local string FName$
Local integer y,FNum
FNum=top
For y=yc To yc+hc
  Print @(xc*8,y*12);
  FName$=FList$(FNum)
  If FName$<>"" Then
    FName$=Mid$(FName$,1,wc)
    FName$=FName$+Space$(wc-Len(Fname$))
    Print FName$
    Inc FNum
  Else
    Print Space$(wc)
  EndIf
Next
End Sub
'PRINT HELP ---------------------
Sub PrintHelp()
Color c(15),c(1)
OpenWindow("Help",10,6,59,20)
Print @(13*8,9*12) "FM -- File Manager for PicoMiteVGA by JAVAVI (c)2024"
Print @(12*8,11*12) "Version 1.3"
Print @(12*8,13*12)"[F1]...[F9] Keys - Conrol Functions"
Print @(12*8,15*12)"[Alt]+[F1]...[F9] Keys - Alternate Conrol Functions"
Print @(12*8,17*12)"[Enter] Key - Entering a folder, running a file "
Print @(12*8,19*12)"[Esc] Key - Exit in MMBasic command prompt. "
Do :Loop Until Inkey$<>""
Color c(15),c(0)
End Sub
'PRINT Watch Time------------------------
Sub PrintTime()
  Tick1s=0
  Colour c(14),c(1)
  Print @(600,0);Mid$(Time$,1,5);
  Colour c(15),c(0)
End Sub
'PRINT FUNCTION KEY MENU ------------------------------
Sub PrintFMenu()
Print @(0,480-12);
Print  "F1"; :Color 0,c(7):Print "Help  ";:Color c(15),0
Print " F2"; :Color 0,c(7):Print "ReName";:Color c(15),0
Print " F3"; :Color 0,c(7):Print "List  ";:Color c(15),0
Print " F4"; :Color 0,c(7):Print "Edit  ";:Color c(15),0
Print " F5"; :Color 0,c(7):Print "Copy  ";:Color c(15),0
Print " F6"; :Color 0,c(7):Print "Move  ";:Color c(15),0
Print " F7"; :Color 0,c(7):Print "MkDir ";:Color c(15),0
Print " F8"; :Color 0,c(7):Print "Delete";:Color c(15),0
Print " F9"; :Color 0,c(7):Print "Menu  ";:Color c(15),0
'Print " Esc";:Color 0,c(7):Print "EXIT ";:Color c(15),0
End Sub
'----------------------------
Sub PrintAltFMenu()
Print @(0,480-12);
Print  "F1"; :Color 0,c(7):Print "Left  ";:Color c(15),0
Print " F2"; :Color 0,c(7):Print "Right ";:Color c(15),0
Print " F3"; :Color 0,c(7):Print "      ";:Color c(15),0
Print " F4"; :Color 0,c(7):Print "      ";:Color c(15),0
Print " F5"; :Color 0,c(7):Print "      ";:Color c(15),0
Print " F6"; :Color 0,c(7):Print "      ";:Color c(15),0
Print " F7"; :Color 0,c(7):Print "      ";:Color c(15),0
Print " F8"; :Color 0,c(7):Print "      ";:Color c(15),0
Print " F9"; :Color 0,c(7):Print "      ";:Color c(15),0
End Sub
'==========================================================
'SCREEN SAVER - Matrix
Sub SSMatrix
Local matr(CHR),fade(CHR),clr,x
For x=1 To CHR:matr(x)=CVR*Rnd:fade(x)=&hF*Rnd:Next
Do
  For x=1 To CHR
    clr=&h1000*(fade(x)-&hF) And &hFF00
    Colour clr
    Print @(x*FW-FW,matr(x)*FH)Chr$(Rnd*223+32); '95
    If matr(x)>CVR  Then matr(x)=0 Else Inc matr(x)
    If fade(x)=&hF0 Then fade(x)=0 Else Inc fade(x)
  Next
  Pause 10
Loop While Inkey$=""
Colour c(15)
End Sub
